#ifndef DECODERTHREAD_H
#define DECODERTHREAD_H

#include <QThread>
#include <QMap>
#include <QStack>

class DecoderThread : public QThread
{
    Q_OBJECT
public:
    explicit DecoderThread(QObject *parent = 0);
    ~DecoderThread();
    void decode(QByteArray program, QByteArray input);

private:
    QByteArray program;
    QByteArray input;

    void run();
    void actualDecode(char* program, int programLength, char* input, int inputLength);

signals:
    void programDecoded(QString text);
    void errorMessage(QString text);

public slots:

};

#endif // DECODERTHREAD_H
